fCT = CreateFrame("Frame", "fFB", UIParent);

-- Globals
local LOOT_SELF_REGEX = gsub(LOOT_ITEM_SELF, "%%s", "(.+)") -- credit to Morgalm http://forums.wowace.com/showthread.php?t=17915
local LOOT_REGEX = gsub(LOOT_ITEM, "%%s", "(.+)")           -- credit to Morgalm http://forums.wowace.com/showthread.php?t=17915
local LOOT_RECEIVE_REGEX = gsub(LOOT_ITEM_PUSHED_SELF,  "%%s", "(.+)")
local LOOT_COUNT = "x.\."; -- used to match the number of items looted if more than one
local SOUNDON = true;

-- s:gsub(pattern, replace [,n])
-- Felblight = "127759", LunkerA = "122696", LunkerB = "127994", LunkerC = "116820", LunkerD = "116819", LunkerE = "116818", LunkerF = "116822", LunkerG = "116821", LunkerH = "116817"
-- Test Items DulledClaw = "106867", Raw Beast Scraps = 110610
-- Load base items (Felblight and lunkers)
-- FarmItems = {127759, 122696, 127994, 116820, 116819, 116818, 116822, 116821, 116817};  -- Table to store farming items itemID; keys start at 1
FarmItems = {127759, 122696, 127994, 116820, 116819, 116818, 116822, 116821, 116817};

SLASH_FB1 = "/fb"
SlashCmdList["FB"] = function(msg)
    -- parse msg
    local CmdTable = { string.split(" " , msg) };

    if CmdTable[1] == "list" then
         FarmingBuddy_ListItems()
        return
    elseif CmdTable[1] == "add" then  
        -- Parse msg for items to add
        -- 1.  See if there is a bracket indicating linked object
        x, y = string.find(msg,'%[')
        if x then
            -- possible linked object
            a, b = string.find(msg, '%]')
            d = string.sub(msg, x+1, b-1) 
            local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice = GetItemInfo(d);
            local _, _, Color, Ltype, Id, Enchant, Gem1, Gem2, Gem3, Gem4, Suffix, Unique, LinkLvl, Name = string.find(itemLink, "|?c?f?f?(%x*)|?H?([^:]*):?(%d+):?(%d*):?(%d*):?(%d*):?(%d*):?(%d*):?(%-?%d*):?(%-?%d*):?(%d*):?(%d*):?(%-?%d*)|?h?%[?([^%[%]]*)%]?|?h?|?r?")
            local n = tonumber(Id)
            FarmingBuddy_AddItem(n)
            return
        else
            -- use cmdlist item
            local n = tonumber(CmdTable[2]);
            if n then
                FarmingBuddy_AddItem(n)
                return
            end
        end
    elseif CmdTable[1] == "remove" then    
        -- NEEDS error correction
        local n = tonumber(CmdTable[2]);
        if n then 
            FarmingBuddy_RemoveItem(n)
            return
        end 
    elseif CmdTable[1] == "soundoff" then
        SOUNDON = false;
        print("Level Up sound is turned off for looting items")
        return
    elseif CmdTable[1] == "soundon" then
        SOUNDON = true;
        print("Level Up sound is turned on for looting items")
        return
    else
        print("/fb list for listing of farmed items")
        print("/fb add # to add an item to the list")
        print("/fb remove INDEX# to remove item from the list")
        print("/fb soundoff to turn off sound")
        print("/fb soundon to turn on sound")
        print("/fb anything else for this menu list")
    end
end

-- Process captured events
function FarmingBuddy_OnEvent(self, event, msg, sender, language, channelString, target, flags, unk, channelNumber, channelName, unknown, counter)
   if event == "CHAT_MSG_LOOT" then
   	    local _, _, sPlayer, itemlink = string.find(msg, LOOT_REGEX) -- check to see if another player received loot instead, will have two strings
		if not sPlayer then 
		    _, _, itemlink = string.find(msg, LOOT_SELF_REGEX)   -- check to see if self received loot, will have one string, itemlink
		end
		if not itemlink then   
			_, _, itemlink = string.find(msg, LOOT_RECEIVE_REGEX)     -- check to see if received item vice loot
		end
		if not itemlink then
			return -- if no itemlink to check, get out
		end
		_, _, sitemID = string.find(itemlink, "item:(%d+):")      -- parse itemlink to separate itemID from link and count (%d) if present
	    itemID = tonumber(sitemID);
	 
        for k, v in pairs(FarmItems) do -- will loop for each unique item in pairs
                    if itemID == v then
                    	itemCount = 1;
                    	s, f = string.find(msg, LOOT_COUNT);
	  					if s then 
	 			 			sitemCount = string.sub(msg, s+1, f-1);
	 			 			itemCount = tonumber(sitemCount);
					 	end;
                      local mesg = "You looted "..select(2,GetItemInfo(v)).. " and have "..(GetItemCount(v) + itemCount)..".";
                      CombatText_AddMessage(mesg, COMBAT_TEXT_SCROLL_FUNCTION,0.00,1.00,0.04, "crit", isStaggered)
                      if SOUNDON then PlaySound("LEVELUPSOUND", "master") end
                      break; -- get out of for/do loop if item found
                    end
        end  -- end for loot
       
    end -- if event CHAT_MSG_LOOT
end -- end function on event

function FarmingBuddy_ListItems()

   	 for k, v in pairs (FarmItems)  do
   	 		if GetItemInfo(v) ~= nil then
   	          print("Item: "..k.." Name: "..select(2,GetItemInfo(v)));
			end
   	 end  
end

function FarmingBuddy_AddItem(value)
    
    -- Get size of table and increment by 1
    local NewIncrement = table.getn(FarmItems) + 1;
    
    if GetItemInfo(value) then 
        -- add new value at next index
    	table.insert(FarmItems, NewIncrement, value);
    	print("Item "..select(2,GetItemInfo(value)).." added." )
   	end
   
end

function FarmingBuddy_RemoveItem(ind)

   if table.getn(FarmItems) >= ind then
        delItem = FarmItems[ind];
        table.remove(FarmItems, ind)
        print("Item "..select(2,GetItemInfo(delItem)).." removed." )
    else
        print("No such index, please check /fb list again")
    end
    
end

function FarmingBuddy_OnLoad()
   
	fFB:SetWidth(100); -- Set these to whatever height/width is needed 
	fFB:SetHeight(20); -- for your Texture
	fFB:SetPoint("TOPLEFT", "UIParent");
    -- Register any events that are a result of looting corpses or bosses
    fFB:RegisterEvent("CHAT_MSG_LOOT");
	fFB:HookScript("OnEvent", FarmingBuddy_OnEvent);
	
--  API Note: If the item hasn't been encountered since the game client was last started, this function will initially return nil, 
--  but will asynchronously query the server to obtain the missing data.[1]	
	-- Run a ListItems in order to cache the preloaded items (Felblight and Lunkers)
	 FarmingBuddy_ListItems();
	
end

FarmingBuddy_OnLoad();